
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>6.3. [U4.21.01] : Operator LIRE_MAILLAGE (READ_MESH) &#8212; Code-Aster v14 0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/app.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="../../_static/code_aster.css" />
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="6.4. [U4.22.01] : Operator DEFI_GROUP (DEFINE_GROUP)" href="u4.22.01.html" />
    <link rel="prev" title="6.2. [U4.11.01] : Procedure DEBUT" href="u4.11.01.html" />

<script type="text/javascript" src="../../_static/sidebar.js"></script>

<link rel="stylesheet" href="https://use.typekit.net/isi7ftn.css">
<script>try{Typekit.load({ async: true });}catch(e){}</script>
<script type="text/javascript" src="../../_static/copybutton.js"></script>


  </head><body>
<div class="topbar">
  <!--
  <a class="brand" title="Documentation Home" href="../../index.html">
    <span id="logotext">LSST Science Pipelines</span>
  </a>
  -->
  <ul>
    <li><a href="https://www.code-aster.org/V2/spip.php?rubrique19">Code Aster PDF Docs</a></li>
  </ul>
</div>

<div class="related">
    <h3>Navigation</h3>
    <ul>
      <li class="right">
	<a href="u4.22.01.html" title="6.4. [U4.22.01] : Operator DEFI_GROUP (DEFINE_GROUP)">
	  next &raquo;
	</a>
      </li>
      <li class="right">
	<a href="u4.11.01.html" title="6.2. [U4.11.01] : Procedure DEBUT">
	  &laquo; previous
	</a>
	 |
      </li>
      <li>
	<a href="../../index.html">Code-Aster v14 0.1 documentation</a>
	 &#187;
      </li>
      <li><a href="u4_toc.html" accesskey="U"><span class="section-number">6. </span><strong>U4</strong>: Command documentation</a> &#187;</li>
      
      <li><span class="section-number">6.3. </span><strong>[U4.21.01]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">LIRE_MAILLAGE</span></code> (<span class="gray">READ_MESH</span>)</li> 
    </ul>
</div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="u4-21-01-operator-lire-maillage-read-mesh">
<span id="u4-21-01"></span><span id="index-0"></span><h1><span class="section-number">6.3. </span><strong>[U4.21.01]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">LIRE_MAILLAGE</span></code> (<span class="gray">READ_MESH</span>)<a class="headerlink" href="#u4-21-01-operator-lire-maillage-read-mesh" title="Permalink to this headline">¶</a></h1>
<div class="section" id="purpose">
<span id="u4-21-01-1"></span><h2><span class="section-number">6.3.1. </span>Purpose<a class="headerlink" href="#purpose" title="Permalink to this headline">¶</a></h2>
<p>Create a mesh by reading from a file.</p>
<p>The supported file formats are: <span class="green">ASTER</span>, <span class="green">MED</span>, <span class="green">GIBI</span>, <span class="green">GMSH</span> and <span class="green">IDEAS</span>.</p>
<p>The output is a data structure of the <span class="green">maillage</span> (<span class="gray">mesh</span>) type.</p>
<div class="admonition-important-note admonition">
<p class="admonition-title">Important note</p>
<p>One can check the quality of the mesh by using the command <span class="red">MACR_INFO_MAIL</span> <span class="xref std std-ref">[U7.03.02]</span>
after reading the mesh with <span class="red">LIRE_MAILLAGE</span>.</p>
</div>
</div>
<div class="section" id="syntax">
<span id="u4-21-01-2"></span><h2><span class="section-number">6.3.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>mesh [maillage] = LIRE_MAILLAGE(

  ◊ UNITE = / 20,                                   [DEFAULT]
            / i,                                    [I]
  ◊ FORMAT = / &#39;MED&#39;,                               [DEFAULT]
             / &#39;ASTER&#39;,
             / &#39;GIBI&#39;,
             / &#39;GMSH&#39;,
             / &#39;IDEAS&#39;,

  # If FORMAT = &#39;MED&#39;

  ◊ NOM_MED = med_name,                             [K*]
  ◊ INFO_MED = / 1,                                 [DEFAULT]
               / 2,
               / 3,

  # If FORMAT = &#39;IDEAS&#39;

  ◊ CREA_GROUP_COUL = / &#39;NON&#39;,                      [DEFAULT]
                      / &#39;OUI&#39;,

  ◊ VERI_MAIL = _F(
                   ◊ VERIF = / &#39;OUI&#39; ,              [DEFAULT]
                             / &#39;NON&#39; ,
                  ),

  ◊ APLAT = / 1.D-3,                                [DEFAULT]
            / ap,                                   [R]

  ◊ INFO = / 1,                                     [DEFAULT]
           / 2,
)
</pre></div>
</div>
</div>
<div class="section" id="operands">
<span id="u4-21-01-3"></span><h2><span class="section-number">6.3.3. </span>Operands<a class="headerlink" href="#operands" title="Permalink to this headline">¶</a></h2>
<div class="section" id="operand-unite">
<span id="u4-21-01-3-1"></span><h3><span class="section-number">6.3.3.1. </span>Operand <span class="blue">UNITE</span><a class="headerlink" href="#operand-unite" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ UNIT = i
</pre></div>
</div>
<p>Logical unit number of the mesh file. Unit 20 by default.</p>
</div>
<div class="section" id="operand-format">
<span id="u4-21-01-3-2"></span><h3><span class="section-number">6.3.3.2. </span>Operand <span class="blue">FORMAT</span><a class="headerlink" href="#operand-format" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ FORMAT = / &#39;MED&#39;                   [DEFAULT]
           / &#39;ASTER&#39;
           / &#39;GIBI&#39;
           / &#39;GMSH&#39;
           / &#39;IDEAS&#39;
</pre></div>
</div>
<p>This keyword is used to specify the format of the file to be read.</p>
<p>The format <span class="blue">ASTER</span> is described in <a class="reference internal" href="u3.01.00.html#u3-01-00"><span class="std std-ref">[U3.01.00]</span></a>.</p>
<p>The <span class="blue">MED</span> format, which means “Modeling and Data Exchange”, is a neutral data format developed by
EDF R&amp;D and the CEA for data exchanges between computer codes. The data that can be exchanged according to
this format are the meshes and the result fields: fields at nodes, fields by element.
<span class="blue">MED</span> files are binary and portable files (based on the <code class="docutils literal notranslate"><span class="pre">HDF</span></code> library, Hierarchical Data Format).
Reading a <span class="blue">MED</span> file with <span class="red">LIRE_MAILLAGE</span> allows the user to input a mesh produced by any other
code capable of creating a <span class="blue">MED</span> file. This is the format advised in <code class="docutils literal notranslate"><span class="pre">Code_Aster</span></code> and is the default.</p>
<p>Whatever the format, the data read are:</p>
<ul class="simple">
<li><p>the list of nodes : number, name, contact details,</p></li>
<li><p>the list of elements : number, name, type, name of the nodes,</p></li>
<li><p>the list of nodes groups : number, name, number of nodes, names of nodes,</p></li>
<li><p>the list of element groups : number, name, number of meshes, names of elements.</p></li>
</ul>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>In a <span class="blue">MED</span> file, there is a partition of the nodes and elements according to groups. A partition
corresponds to a <span class="blue">MED</span> family. In a <span class="blue">MED</span> file, the groups are distributed within families:
there are therefore families of nodes and families of elements. During the reading of a <span class="blue">MED</span> file,
lists of groups of nodes and elements are created on the fly by breaking down families.</p>
</div>
</div>
<div class="section" id="operand-veri-mail-check-mesh">
<span id="u4-21-01-3-3"></span><h3><span class="section-number">6.3.3.3. </span>Operand <span class="blue">VERI_MAIL</span> (<span class="gray">CHECK_MESH</span>)<a class="headerlink" href="#operand-veri-mail-check-mesh" title="Permalink to this headline">¶</a></h3>
<p>The keyword <span class="blue">VERI_MAIL</span> triggers 3 checks on the mesh:</p>
<ul class="simple">
<li><p>absence of orphan nodes,</p></li>
<li><p>absence of “duplicate” elements,</p></li>
<li><p>absence of excessively flat elements.</p></li>
</ul>
<p>If these checks are not satisfied, the code issues an alarm.</p>
<p>By default (i.e., in the absence of the keyword <span class="blue">VERI_MAIL</span>), the checks are performed.  If the user
wants to avoid these checks, they can use:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">VERI_MAIL</span> <span class="o">=</span> <span class="n">_F</span><span class="p">(</span><span class="n">VERIF</span> <span class="o">=</span> <span class="s1">&#39;NON&#39;</span><span class="p">,)</span>
</pre></div>
</div>
<p>A node is declared to be an orphan if it is not part of the connectivity of any element.</p>
<p>An element is declared to be “duplicate” if 2 elements (or more) have connectivities formed by the same
list of nodes.</p>
<p>The keyword <span class="blue">APLAT = ap</span> makes it possible to emit alarms when the mesh contains too many flat elements.
The flatness of an element is defined as the <code class="docutils literal notranslate"><span class="pre">Amin</span> <span class="pre">/</span> <span class="pre">Amax</span></code> ratio where <code class="docutils literal notranslate"><span class="pre">Amin</span></code> and <code class="docutils literal notranslate"><span class="pre">Amax</span></code> are the
shortest and longest edge lengths of the element. The name of the elements for which the flatness is less
than <span class="green">ap</span> will be printed in the ‘MESSAGE’ file.</p>
<p>Other quality criteria for the mesh are available via the command <span class="red">MACR_INFO_MAIL</span>
<span class="xref std std-ref">[U7.03.02]</span>.</p>
</div>
<div class="section" id="operands-for-the-format-med">
<span id="u4-21-01-3-4"></span><h3><span class="section-number">6.3.3.4. </span>Operands for the format <span class="blue">‘MED’</span><a class="headerlink" href="#operands-for-the-format-med" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ NOM_MED = med_name,
</pre></div>
</div>
<p>A <span class="blue">MED</span> file can contain several meshes. Each mesh is identified by its name. To read a particular mesh,
it is necessary to provide its name in the argument of the keyword <span class="blue">NOM_MED</span>. Without the keyword, the
first mesh found in the file will be read. When the file contains only one mesh there is no need to specify
a mesh name.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ INFO_MED = / 1,                  [DEFAULT]
             / 2,
             / 3,
</pre></div>
</div>
<p>Print specific information during the course of reading the <span class="blue">MED</span> mesh file (number of nodes and meshes
read again, information on the MED families, etc.):</p>
<ul class="simple">
<li><p><span class="blue">INFO_MED = 1</span>: no printing,</p></li>
<li><p><span class="blue">INFO_MED = 2</span>: only messages relating to family correspondence/group,</p></li>
<li><p><span class="blue">INFO_MED = 3</span>: all the information is printed.</p></li>
</ul>
</div>
<div class="section" id="operands-for-the-format-ideas">
<span id="u4-21-01-3-5"></span><h3><span class="section-number">6.3.3.5. </span>Operands for the format <span class="blue">‘IDEAS’</span><a class="headerlink" href="#operands-for-the-format-ideas" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ CREA_GROUP_COUL
</pre></div>
</div>
<p>The user can ask for the creation of mesh groups and nodes by collecting all the elements and nodes of the
same color by indicating <span class="blue">CREA_GROUP_COUL = ‘OUI’</span>. These groups are named <span class="green">COUL_n</span> where
<span class="green">n</span> is the number of the color in <span class="blue">IDEAS</span>.</p>
<p>By default this is not done so as not to unnecessarily increase the number of element and node groups.</p>
<div class="admonition-remarks admonition">
<p class="admonition-title">Remarks</p>
<ul class="simple">
<li><p>We only deal with Cartesian coordinate systems.</p></li>
<li><p>Only one Cartesian coordinate system is managed.</p></li>
<li><p>During the conversion of the universal <span class="blue">IDEAS</span> file, it is checked whether the user has defined
several coordinate systems. If this is the case, an alarm message warns the user, to ask them to verify
that all coordinate systems are the same.</p></li>
</ul>
</div>
</div>
<div class="section" id="operand-info">
<span id="u4-21-01-3-6"></span><h3><span class="section-number">6.3.3.6. </span>Operand <span class="blue">INFO</span><a class="headerlink" href="#operand-info" title="Permalink to this headline">¶</a></h3>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>◊ INFO = / 1,                    [DEFAULT]
         / 2,
</pre></div>
</div>
<p>Printing level.</p>
<p>If <span class="blue">INFO = 1</span>, output</p>
<ul class="simple">
<li><p>mesh title,</p></li>
<li><p>number of nodes,</p></li>
<li><p>number of elements of each type,</p></li>
<li><p>number of groups of nodes and for each of them its name and the number of nodes of the group</p></li>
<li><p>number of element groups and for each of them its name and the number of elements in the group.</p></li>
</ul>
<p>If <span class="blue">INFO = 2</span>, one prints the following additional information:</p>
<ul class="simple">
<li><p>list of nodes : number, name, contact details,</p></li>
<li><p>element list : number, name, type, name of the nodes,</p></li>
<li><p>list of node groups : number, name, number of nodes, names of nodes,</p></li>
<li><p>list of element groups : number, name, number of elements, names of elements.</p></li>
</ul>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<form action="../../search.html" method="get">
  <input class='c-searchbox' type="text" name="q" placeholder="Search" />
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form><div>
   <h3>Quick search</h3>
   <script async src="https://cse.google.com/cse.js?cx=1913d02e421931d61"></script>
   <div class="gcse-search"></div>
</div><h3>On this page</h3>
<ul>
<li><a class="reference internal" href="#">6.3. <strong>[U4.21.01]</strong> : Operator <code class="docutils literal notranslate"><span class="pre">LIRE_MAILLAGE</span></code> (<span class="gray">READ_MESH</span>)</a><ul>
<li><a class="reference internal" href="#purpose">6.3.1. Purpose</a></li>
<li><a class="reference internal" href="#syntax">6.3.2. Syntax</a></li>
<li><a class="reference internal" href="#operands">6.3.3. Operands</a><ul>
<li><a class="reference internal" href="#operand-unite">6.3.3.1. Operand <span class="blue">UNITE</span></a></li>
<li><a class="reference internal" href="#operand-format">6.3.3.2. Operand <span class="blue">FORMAT</span></a></li>
<li><a class="reference internal" href="#operand-veri-mail-check-mesh">6.3.3.3. Operand <span class="blue">VERI_MAIL</span> (<span class="gray">CHECK_MESH</span>)</a></li>
<li><a class="reference internal" href="#operands-for-the-format-med">6.3.3.4. Operands for the format <span class="blue">‘MED’</span></a></li>
<li><a class="reference internal" href="#operands-for-the-format-ideas">6.3.3.5. Operands for the format <span class="blue">‘IDEAS’</span></a></li>
<li><a class="reference internal" href="#operand-info">6.3.3.6. Operand <span class="blue">INFO</span></a></li>
</ul>
</li>
</ul>
</li>
</ul>


        </div>
      </div>
      <div class="clearer"></div>
    </div>
<footer class="footer">
  <p class="pull-right">
    <a href="../../_sources/docs/user/u4.21.01.rst.txt"
       rel="nofollow">Page Source</a> &nbsp;
    <a href="#">Back to Top</a></p>
  <p>
  </p>
  <p>
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 3.5.1. Page design is based on <a href="https://project.lsst.org">LSST</a> created modifications of Astropy's bootstrap-astropy theme in <a href="https://github.com/astropy/astropy-helpers">astropy-helpers</a>. <br />
  </p>
  <p>
    &copy; Copyright 2021, Biswajit Banerjee.  Original version &copy; Copyright 2019 EDF R&amp;D - Licensed under the terms of the GNU FDL (http://www.gnu.org/copyleft/fdl.html).<br/>
  </p>
</footer>
  </body>
</html>